# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b91"
os.chdir("/home/brettnak/.sage/sage_notebook/worksheets/admin/5/cells/2")
sage.server.notebook.interact.SAGE_CELL_ID=2
class Sensor:
    """
    __init__(self, id, key_ring, location, name = None, neighbors = None)
       Required
        id:        Integer
        key_ring:  Iterable Collection
        location:  (xmin, xmax, ymin, ymax)

       Optional
        name:      any object with a defined repr, default None
    """

    def __init__(self, id, key_ring, location, name = None, neighbors = None):
        self.key_ring = key_ring
        self.location = location
        self.id = id
        self.name = name
        self.neighbors = None
        self.compromised = false
        if neighbors == None:
            self.neighbors = []
        else:
            self.neighbors = neighbors

    def get_common_keys(self, node):
        common_keys = []
        for i in self.key_ring:
            for j in node.key_ring:
                if i == j:
                    common_keys.append(i)
        return common_keys

    def has_common_key(self, node):
        for i in (ellipsis_range(Integer(1),Ellipsis,len(self.key_ring))):
            for j in (ellipsis_range(Integer(1),Ellipsis,len(node.key_ring))):
                if s == o: return true
        return false

    def add_neighbor(self, node):
        self.neighbors.append(node)

    def remove_neighbor(self, node):
        try: self.neighbors.remove(node)
        except ValueError: pass

    def compromise(self):
        self.compromised = true
        return deepcopy(self.key_ring)

    def is_in_range(self, node, range):
        dist = (float(self.location[Integer(0)]) - float(node.location[Integer(0)]))**Integer(2)
        dist += (self.location[Integer(1)] - node.location[Integer(1)])**Integer(2)
        dist = sqrt(dist)
        return dist < range

    def get_distance(self, node):
        dist = (float(self.location[Integer(0)]) - float(node.location[Integer(0)]))**Integer(2)
        dist += (self.location[Integer(1)]- node.location[Integer(1)])**Integer(2)
        dist = sqrt(dist)
        return dist

    def __hash__(self):
        return int(self.id * Integer(37))

print "e91"
